SystemOrganization addCategory: #ConfigurationOfPaillier!

Object subclass: #ConfigurationOfPaillier
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPaillier'!

!ConfigurationOfPaillier class methodsFor: 'development support' stamp: 'NicolasVanderAuwera 10/30/2012 15:12'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPaillier class methodsFor: 'private' stamp: 'NicolasVanderAuwera 10/30/2012 15:12'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPaillier class methodsFor: 'private' stamp: 'NicolasVanderAuwera 10/30/2012 15:12'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPaillier class methodsFor: 'private' stamp: 'NicolasVanderAuwera 10/30/2012 15:12'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPaillier class methodsFor: 'metacello tool support' stamp: 'NicolasVanderAuwera 10/30/2012 15:12'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPaillier class methodsFor: 'loading' stamp: 'NicolasVanderAuwera 10/30/2012 15:12'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPaillier class methodsFor: 'loading' stamp: 'NicolasVanderAuwera 10/30/2012 15:12'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPaillier class methodsFor: 'loading' stamp: 'NicolasVanderAuwera 10/30/2012 15:12'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPaillier class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/30/2012 15:12'!
project

	^self new project! !

!ConfigurationOfPaillier class methodsFor: 'development support' stamp: 'NicolasVanderAuwera 10/30/2012 15:12'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPaillier methodsFor: 'baselines' stamp: 'NicolasVanderAuwera 11/14/2012 14:55'!
baseline10: spec
	<version: '1.0-baseline'>
	spec
		for: #common
		do: [ 
			spec
				blessing: #baseline;
				repository: 'http://ss3.gemstone.com/ss/Paillier'.
			spec package: 'Cryptography' with: [ spec repository: 'http://www.squeaksource.com/Cryptography' ].
			spec package: 'Paillier' with: [ spec requires: #('Cryptography') ] ]! !

!ConfigurationOfPaillier methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/30/2012 15:12'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPaillier methodsFor: 'symbolic versions' stamp: 'NicolasVanderAuwera 10/30/2012 15:15'!
stable: spec
	<symbolicVersion: #stable>
	spec for: #common version: '1.0'! !

!ConfigurationOfPaillier methodsFor: 'versions' stamp: 'NicolasVanderAuwera 10/30/2012 15:14'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	spec
		for: #common
		do: [ 
			spec
				blessing: #development;
				author: 'Nicolas Vander Auwera';
				timestamp: '27/04/2012 09:26';
				package: 'Paillier' ]! !
